program Proba;
uses crt;
type ptrrij=^r;
     ptrlin=^l;
     r=record
             rijec:string; {sadri rijeci teksta}
             pll:ptrlin;   {pokaziva na listu linija}
             psr:ptrrij;   {pokazivac na slijedecu rijec u listi}
       end;
     l=record
             lin:integer;  {broj linije}
             psl:ptrlin;   {pokazivac na slijedeci broj linije u tekstu}
       end;
var
brlin,brojac:integer;
linija:array [1..50] of string;
prvarij,p,pomr:ptrrij;
lini:ptrlin;

function jeslovo (c:char):boolean;{provjerava da li je karakter slovo}
begin
      jeslovo:=(((c>='a') and (c<='z')) or ((c>='A') and (c<='Z')));
end;

procedure Pronadji(wo:string);
var t:ptrrij;
begin
     t:=prvarij;
     while t<>NIL do
           begin
                if wo>t^.rijec then t:=t^.psr
                else
                   begin p:=t;t:=NIL end
           end;
end;

procedure Ubaci(var wo:string;bl:integer);
var poml:ptrlin;
begin
     if wo=p^.rijec then
           begin
                poml:=p^.pll;
                while poml^.psl<>NIL do poml:=poml^.psl;
                new(lini);
                lini^.lin:=bl;
                lini^.psl:=NIL;
                poml^.psl:=lini
           end
     else
          begin
               new(pomr);
               pomr^.rijec:=p^.rijec;
               pomr^.psr:=p^.psr;
               pomr^.pll:=p^.pll;
               p^.rijec:=wo;
               p^.psr:=pomr;
               new(lini);
               lini^.lin:=bl;
               lini^.psl:=NIL;
               p^.pll:=lini;
          end;
end;

procedure Init;
begin
     new(prvarij);
     prvarij^.rijec:='zzzzzzzzzz';
     prvarij^.psr:=NIL;
     prvarij^.pll:=NIL;
     lini:=NIL
end;

procedure Oslobodi(var osl:ptrrij);
var b:ptrlin;
begin
     lini:=osl^.pll;
     while lini<>NIL do
           begin
                b:=lini^.psl;
                dispose(lini);
                lini:=b;
           end;
end;

procedure Isprazni;
Var t:ptrrij;
begin
     pomr:=prvarij^.psr;
     dispose(prvarij);
     Oslobodi(prvarij);
     while pomr<>NIL do
           begin
                t:=pomr;
                dispose(pomr);
                Oslobodi(pomr);
                pomr:=t^.psr;
           end;
end;

procedure UcitajTekst;
begin
  clrscr;
  brlin:=0;
  writeln('Ukucajte tekst,za prekid napiite "kraj".');
  writeln('-----------------------------------------------------------------------------');
  repeat
        begin
        brlin:=brlin+1;
        readln(linija[brlin]);
        end;
  until linija[brlin]='kraj'
end;

procedure ObradiLiniju;{izdvaja rijei iz linija teksta i poziva procedure}
var i,duzina,brslo,tekuceslovo:integer;{pronadji i ubaci.}
word:string;
begin
  for i:=1 to brlin-1 do
  begin
    tekuceslovo:=1;
    duzina:=length(linija[i]);
    while tekuceslovo<=duzina do
      begin
        if not jeslovo(linija[i][tekuceslovo]) then
               tekuceslovo:=tekuceslovo+1
        else
          begin
                brslo:=0;
                while jeslovo(linija[i][tekuceslovo]) do
                  begin
                    brslo:=brslo+1;
                    word[brslo]:=linija[i][tekuceslovo];
                    word[0]:=chr(brslo);
                    tekuceslovo:=tekuceslovo+1;
                  end;
                  if brslo>1 then
                  begin
                    Pronadji(word);
                    Ubaci(word,i);
                  end;
          end;
      end;
  end;
end;

procedure NoviProzor;
begin
     gotoxy(1,brojac);brojac:=1;
     writeln('Za stampanje ostatka teksta stisni tipku "space".');
     repeat until readkey=' ';
     clrscr;gotoxy(32,1)
end;

procedure Stampaj;
var pompoin:ptrrij;
    pomlin:ptrlin;
    ukupno,kon:integer;
begin
     if brlin<10 then Window(1,brlin+6,80,25)
     else
         begin
              clrscr;
              Writeln('*****************************************************************************');
              Writeln('R i j e c:                 pojavljuje se u linijama:                 ukupno:');
              Window(1,4,80,25);
              brlin:=-1;
              end;
     brojac:=0;
     pompoin:=prvarij;
     while pompoin^.psr<>NIL do
           begin
                ukupno:=0;kon:=0;
                brojac:=brojac+1;
                if brojac>19-brlin then NoviProzor;
                gotoxy(2,brojac);
                write(pompoin^.rijec);
                pomlin:=pompoin^.pll;
                gotoxy(32,brojac);
                while pomlin<>NIL do
                    begin
                      if kon>9 then
                         begin
                           kon:=0;brojac:=brojac+1;
                           gotoxy(32,brojac);
                         end;
                      if brojac>19-brlin then NoviProzor;
                      write(pomlin^.lin,'  ');
                      ukupno:=ukupno+1;kon:=kon+1;
                      pomlin:=pomlin^.psl;
                    end;
                      gotoxy(73,brojac);
                      writeln(ukupno);
                      pompoin:=pompoin^.psr;
                 end;
end;

begin{glavni program }
repeat
Init;
UcitajTekst;
ObradiLiniju;
Writeln('*****************************************************************************');
Writeln('R i j e c:                 pojavljuje se u linijama:                 ukupno:');
Stampaj;
Writeln('################################  E  N  D  ##################################');
Window(1,1,80,25);
Gotoxy(1,23);
Writeln('*****************************************************************************');
Writeln('            izlaz iz programa--q **** obrada novog teksta--tipka<>q          ');
Isprazni;
until readkey='q'
end.
